<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Quản lý Contacts - Food Ordering</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Contact</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8;"
          />
          <span class="brand-text font-weight-light">DEVCAMP</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Le Nguyen</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Home</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Contact</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Quản lý Contacts - Food Ordering</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Contact</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">
          <!-- Default box -->
          <div class="card">
            <!-- Vùng header -->
            <div class="container">
              <div class="form-group mt-3">
                <button class="btn btn-success" id="btn-add-contact">
                  <i class="fa fa-plus"></i>&nbsp; New contact
                </button>
              </div>
            </div>
            <!-- Vouche Data Table -->
            <div class="container">
              <table
                class="table table-bordered table-striped table-hover"
                id="contact-table"
              >
                <thead>
                  <tr>
                    <th>STT</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Message</th>
                    <th>Create Date</th>
                    <th>Action</th>
                  </tr>
                </thead>
              </table>
            </div>
            <!-- Vùng Modal -->

            <!-- Create contact modal -->
            <div>
              <div id="create-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Create new contact
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <form>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Name</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-contact-name"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Email</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-contact-email"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Message</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-create-contact-message"
                              class="form-control"
                            />
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-secondary"
                        id="btn-create-cancel"
                        data-dismiss="modal"
                      >
                        Cancel
                      </button>
                      <button class="btn btn-primary" id="btn-create-contact">
                        Create contact
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Update contact modal -->
            <div>
              <div id="update-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Update a contact
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <form>
                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Name</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-contact-name"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Email</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-contact-email"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Message</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-contact-message"
                              class="form-control"
                            />
                          </div>
                        </div>

                        <div class="row form-group">
                          <div class="col-sm-4">
                            <label>Create Date</label>
                          </div>
                          <div class="col-sm-8">
                            <input
                              type="text"
                              id="input-update-contact-create-date"
                              class="form-control"
                            />
                          </div>
                        </div>
                      </form>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-secondary"
                        id="btn-update-cancel"
                        data-dismiss="modal"
                      >
                        Cancel
                      </button>
                      <button class="btn btn-primary" id="btn-update-contact">
                        Update contact
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <!-- Delete confirm modal -->
            <div>
              <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Contact Delete Confirmation
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <label
                        >Bạn có chắc chắn muốn xóa contact này không?</label
                      >
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-danger"
                        id="btn-confirm-delete-contact"
                      >
                        Confirm
                      </button>
                      <button class="btn btn-secondary" data-dismiss="modal">
                        Cancel
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- /.card -->
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong>Copyright &copy; 2023 <a href="#">Devcamp</a>.</strong> All
        rights reserved.
      </footer>
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </body>
</html>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Biến toàn cục để lưu trữ id contact đang đc update or delete. Mặc định = 0;
  var gContactId = 0;

  const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";

  // Biến mảng hằng số chứa danh sách tên các thuộc tính
  const gcontact_COLS = [
    "stt",
    "name",
    "email",
    "message",
    "createDate",
    "action",
  ];

  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gSTT_COL = 0;
  const gNAME_COL = 1;
  const gEMAILCOL = 2;
  const gMESSAGE_COL = 3;
  const gCREATE_DATE_COL = 4;
  const gACTION_COL = 5;

  // Biến toàn cục để hiển lưu STT
  var gSTT = 1;
  // Khai báo DataTable & mapping collumns
  var gcontactTable = $("#contact-table").DataTable({
    columns: [
      { data: gcontact_COLS[gSTT_COL] },
      { data: gcontact_COLS[gNAME_COL] },
      { data: gcontact_COLS[gEMAILCOL] },
      { data: gcontact_COLS[gMESSAGE_COL] },
      { data: gcontact_COLS[gCREATE_DATE_COL] },
      { data: gcontact_COLS[gACTION_COL] },
    ],
    columnDefs: [
      {
        // định nghĩa lại cột STT
        targets: gSTT_COL,
        render: function () {
          return gSTT++;
        },
      },
      {
        // định nghĩa lại cột action
        targets: gACTION_COL,
        defaultContent: `
          <img class="edit-contact" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-contact" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `,
      },
    ],
  });

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    // thực hiện tải trang
    onPageLoading();
    // 2 - C: gán sự kiện Create - Thêm mới contact
    $("#btn-add-contact").on("click", function () {
      onBtnAddNewContactClick();
    });
    // 3 - U: gán sự kiện Update - Sửa 1 contact
    $("#contact-table").on("click", ".edit-contact", function () {
      onBtnEditContactClick(this);
    });
    // 4 - D: gán sự kiện Delete - Xóa 1 contact
    $("#contact-table").on("click", ".delete-contact", function () {
      onBtnDeleteContactClick(this);
    });

    // gán sự kiện cho nút Create contact (trên modal)
    $("#btn-create-contact").on("click", function () {
      onBtnCreateContactClick();
    });

    // gán sự kiện cho nút Update contact (trên modal)
    $("#btn-update-contact").on("click", function () {
      onBtnUpdateContactClick();
    });
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm thực thi khi trang được load
  function onPageLoading() {
    // 1 - R: Read / Load contact to DataTable
    getAllContacts();
  }

  // Hàm xử lý sự kiện khi nút Thêm mới đc click
  function onBtnAddNewContactClick() {
    // hiển thị modal trắng lên
    $("#create-contact-modal").modal("show");
  }

  // Hàm xử lý sự kiện khi icon edit contact trên bảng đc click
  function onBtnEditContactClick(paramBtnEdit) {
    // lưu thông tin contactId đang được edit vào biến toàn cục
    gContactId = getContactIdFromButton(paramBtnEdit);
    // load dữ liệu vào các trường dữ liệu trong modal
    getContactById(gContactId);
  }

  // hàm xử lý sự kiện create contact modal click
  function onBtnCreateContactClick() {
    // khai báo đối tượng chứa contact data
    var vContactObj = {
      name: "",
      email: "",
      message: "",
      createDate: "",
    };
    // B1: Thu thập dữ liệu
    getCreateContactData(vContactObj);
    // B2: Validate insert
    var vIsContactValidate = validateContactData(vContactObj);
    if (vIsContactValidate) {
      // B3: insert contact
      $.ajax({
        url: gBASE_URL + "contacts",
        type: "POST",
        contentType: "application/json",
        data: JSON.stringify(vContactObj),
        success: function (paramRes) {
          // B4: xử lý front-end
          handleInsertContactSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }
  }

  // hàm xử lý sự kiện update contact modal click
  function onBtnUpdateContactClick() {
    // khai báo đối tượng chứa contact data
    var vContactObj = {
      name: "",
      email: "",
      message: "",
      createDate: "",
    };
    // B1: Thu thập dữ liệu
    getUpdateContactData(vContactObj);
    // B2: Validate update
    var vIsContactValidate = validateContactData(vContactObj);
    if (vIsContactValidate) {
      // B3: update contact
      $.ajax({
        url: gBASE_URL + "contacts/" + gContactId,
        type: "PUT",
        contentType: "application/json",
        data: JSON.stringify(vContactObj),
        success: function (paramRes) {
          // B4: xử lý front-end
          handleUpdateContactSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    }
  }

  //hàm thực thi khi nút Delete được ấn
  function onBtnDeleteContactClick(paramBtnEdit) {
    $("#delete-confirm-modal").modal("show");
    gContactId = getContactIdFromButton(paramBtnEdit);
    $(document).on("click", "#btn-confirm-delete-contact", function () {
      $.ajax({
        url: gBASE_URL + "contacts/" + gContactId,
        type: "DELETE",
        success: function (paramcontacts) {
          alert("Xóa thành công");
          getAllContacts();
          $("#delete-confirm-modal").modal("hide");
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    });
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm gọi api để lấy all danh sách user đăng ký
  function getAllContacts() {
    $.ajax({
      url: gBASE_URL + "contacts",
      type: "GET",
      success: function (paramcontacts) {
        loadDataTocontactTable(paramcontacts);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      },
    });
  }
  /** load contact array to DataTable
   * in: contact array
   * out: contact table has data
   */
  function loadDataTocontactTable(paramcontactArr) {
    gSTT = 1;
    gcontactTable.clear();
    gcontactTable.rows.add(paramcontactArr);
    gcontactTable.draw();
  }

  // hàm get contact by id
  function getContactById(paramContactId) {
    $.ajax({
      url: gBASE_URL + "contacts/" + paramContactId,
      type: "GET",
      success: function (paramContact) {
        console.log(paramContact);
        showContactDataToModal(paramContact);
      },
      error: function (paramErr) {
        console.log(paramErr.status);
      },
    });
    // hiển thị modal lên
    $("#update-contact-modal").modal("show");
  }

  // hàm show contact obj lên modal
  function showContactDataToModal(paramContact) {
    $("#input-update-contact-name").val(paramContact.name);
    $("#input-update-contact-email").val(paramContact.email);
    $("#input-update-contact-message").val(paramContact.message);
    $("#input-update-contact-create-date").val(paramContact.createDate);
  }

  // hàm thu thập dữ liệu để create contact
  function getCreateContactData(paramcontactObj) {
    paramcontactObj.name = $("#input-create-contact-name").val().trim();
    paramcontactObj.email = $("#input-create-contact-email").val().trim();
    paramcontactObj.message = $("#input-create-contact-message").val().trim();
    paramcontactObj.createDate = getDay();
  }

  // hàm thu thập dữ liệu để update contact
  function getUpdateContactData(paramcontactObj) {
    paramcontactObj.name = $("#input-update-contact-name").val().trim();
    paramcontactObj.email = $("#input-update-contact-email").val().trim();
    paramcontactObj.message = $("#input-update-contact-message").val().trim();
    paramcontactObj.createDate = $("#input-update-contact-create-date")
      .val()
      .trim();
  }

  // hàm validate data
  function validateContactData(paramcontactObj) {
    if (paramcontactObj.name === "") {
      alert("name cần nhập");
      return false;
    }

    if (paramcontactObj.email === "") {
      alert("email cần nhập");
      return false;
    }
    if (validateEmail(paramcontactObj.email) === false) {
      alert("email nhập vào không đúng định dạng!");
      return false;
    }

    if (paramcontactObj.message === "") {
      alert("message cần nhập");
      return false;
    }

    return true;
  }

  // hàm xử lý hiển thị front-end khi thêm contact thành công
  function handleInsertContactSuccess() {
    alert("Thêm contact thành công!");
    getAllContacts();
    resertCreateContactForm();
    $("#create-contact-modal").modal("hide");
  }

  // hàm xử lý hiển thị front-end khi sửa contact thành công
  function handleUpdateContactSuccess() {
    alert("Sửa contact thành công!");
    getAllContacts();
    resertUpdateContactForm();
    $("#update-contact-modal").modal("hide");
  }

  // hàm xóa trắng form create contact
  function resertCreateContactForm() {
    $("#input-create-contact-name").val("");
    $("#input-create-contact-email").val("");
    $("#input-create-contact-message").val("");
  }

  // hàm xóa trắng form update contact
  function resertUpdateContactForm() {
    $("#input-update-contact-name").val("");
    $("#input-update-contact-email").val("");
    $("#input-update-contact-message").val("");
    $("#input-update-contact-create-date").val("");
  }

  // hàm dựa vào button detail (edit or delete) xác định đc id contact
  function getContactIdFromButton(paramButton) {
    var vTableRow = $(paramButton).parents("tr");
    var vcontactRowData = gcontactTable.row(vTableRow).data();
    return vcontactRowData.id;
  }

  //hàm lấy dd/mm/yyyy hiện tại
  function getDay() {
    var d = new Date(),
      month = "" + (d.getMonth() + 1),
      day = "" + d.getDate(),
      year = d.getFullYear();

    if (month.length < 2) month = "0" + month;
    if (day.length < 2) day = "0" + day;

    return [day, month, year].join("/");
  }

  // hàm kiểm tra email đúng định dạng ko?
  function validateEmail(paramEmail) {
    var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    if (paramEmail.match(vValidRegex)) {
      return true;
    } else {
      return false;
    }
  }
</script>
